/*
 * 쐬: 2005/01/10
 *
 */
package jp.starlogic.makotan.jooreport.impl;

import java.io.File;
import java.io.IOException;
import java.net.ConnectException;

import jp.starlogic.makotan.Exception.ConnectRuntimeException;
import jp.starlogic.makotan.Exception.InterruptedRuntimeException;
import jp.starlogic.makotan.jooreport.JooDocumentConverter;
import net.sf.joott.uno.DocumentConverter;
import net.sf.joott.uno.DocumentConverterFactory;
import net.sf.joott.uno.DocumentFormat;

import org.seasar.framework.exception.IORuntimeException;

/**
 * @author makotan
 *
 */
public class JooDocumentConverterImpl implements JooDocumentConverter {
    private String[] ooKickCmd = {"C:\\PROGRA~1\\OPENOF~1.2\\program\\quickstart.exe"};
    private String[] ooKillCmd = {"taskkill","/f","/im","soffice.exe"};;
    private int ooKillCount = 100;
    private static int ooConvertCount = 0;
    private static Process OOo = null;
    private static Object syncObj = new Object();
    private static int useCount = 0;
    private int sleepTime = 10000;
    
    public void init() {
	    synchronized(syncObj) {
	        initNoSync();
		    useCount++;
	    }
    }
    
    private void initNoSync() {
		if(OOo == null) {
			try {
                OOo = Runtime.getRuntime().exec(ooKickCmd);
                java.lang.Thread.sleep(sleepTime);
            } catch (IOException e) {
                throw new IORuntimeException(e);
            } catch (InterruptedException e1) {
                throw new InterruptedRuntimeException(e1);
            }
		}
    }

    public void terminate() {
	    synchronized(syncObj) {
		    useCount--;
		    if(useCount==0) {
		        connectionCloseNoSync();
		    }
	    }
    }
    private void connectionCloseNoSync() {
	    if(OOo==null) {
	        return;
	    }
		try {
			DocumentConverterFactory.getConnection().close();
			OOo.destroy();
	        OOo = null;
			Runtime.getRuntime().exec(ooKillCmd);
			java.lang.Thread.sleep(sleepTime);
        } catch (ConnectException e) {
            throw new ConnectRuntimeException(e);
        } catch (IOException e) {
            throw new IORuntimeException(e);
        } catch (InterruptedException e) {
            throw new InterruptedRuntimeException(e);
        }
    }
    
    public void convert(File sxw,File pdf) {
	    synchronized(syncObj) {
	        ooConvertCount++;
			DocumentConverter converter;
			try {
                converter = DocumentConverterFactory.getConverter();
    			converter.convert(sxw, pdf, DocumentFormat.PDF_WRITER);
            } catch (ConnectException e) {
                throw new ConnectRuntimeException(e);
            } catch (IOException e) {
                throw new IORuntimeException(e);
            }
            if((ooConvertCount-ooKillCount)>=0) {
                ooConvertCount = 0;
    	        connectionCloseNoSync();
    	        initNoSync();
            }
	    }
    }
    

    public String[] getOoKickCmd() {
        return ooKickCmd;
    }
    public void setOoKickCmd(String[] ooKickCmd) {
        this.ooKickCmd = ooKickCmd;
    }
    public String[] getOoKillCmd() {
        return ooKillCmd;
    }
    public void setOoKillCmd(String[] ooKillCmd) {
        this.ooKillCmd = ooKillCmd;
    }
    public int getOoKillCount() {
        return ooKillCount;
    }
    public void setOoKillCount(int ooKillCount) {
        this.ooKillCount = ooKillCount;
    }
    
}
