/*
 * 쐬: 2005/01/10
 *
 */
package jp.starlogic.makotan.jooreport.impl;

import java.io.File;

import junit.framework.TestCase;

/**
 * @author makotan
 *
 */
public class JooDocumentConverterTest extends TestCase {
    public void testConvert() {
        JooDocumentConverterImpl converter = new JooDocumentConverterImpl();
        File sxw = new File("class/ϊt@C.sxw");
        File pdf = new File("class/test01.pdf");
        converter.init();
        converter.convert(sxw,pdf);
        converter.terminate();
        assertTrue(pdf.exists());
        //pdf.delete();
    }

    public void testConvert3000() {
        JooDocumentConverterImpl converter = new JooDocumentConverterImpl();
        File sxw = new File("class/ϊt@C.sxw");
        File pdf = new File("class/test01.pdf");
        converter.init();
        for(int i=0 ; i < 3000; i++) {
	        converter.convert(sxw,pdf);
	        assertTrue(pdf.exists());
	        pdf.delete();
        }
        converter.terminate();
    }
    
    public void testThreadConvert() throws Exception{
        ConvertThread cs1 = new ConvertThread();
        cs1.setConvID(1);
        Thread th1 = new Thread(cs1);
        ConvertThread cs2 = new ConvertThread();
        cs2.setConvID(2);
        Thread th2 = new Thread(cs2);
        ConvertThread cs3 = new ConvertThread();
        cs3.setConvID(3);
        Thread th3 = new Thread(cs3);
        
        th1.start();
        th2.start();
        th3.start();
        
        th1.join();
        th2.join();
        th3.join();
        
    }
    
    
    class ConvertThread implements Runnable {
        private int convID = 0;

        /* ( Javadoc)
         * @see java.lang.Runnable#run()
         */
        public void run() {
            JooDocumentConverterImpl converter = new JooDocumentConverterImpl();
            File sxw = new File("class/ϊt@C.sxw");
            File pdf = new File("class/test" + convID + ".pdf");
            converter.init();
            int loopCount = 150 + (int)(Math.random() * 150); 
            for(int i=0 ; i < loopCount; i++) {
    	        converter.convert(sxw,pdf);
    	        assertTrue(pdf.exists());
    	        pdf.delete();
            }
            converter.terminate();
            
        }
        
        public int getConvID() {
            return convID;
        }
        public void setConvID(int convID) {
            this.convID = convID;
        }
    }


}
